# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# We need to patch the test suite if we have an old version of Test::More
%global old_test_more %(perl -MTest::More -e 'print (($Test::More::VERSION < 0.88) ? 1 : 0);' 2>/dev/null || echo 0)
%global older_test_more %(perl -MTest::More -e 'print (($Test::More::VERSION < 0.82) ? 1 : 0);' 2>/dev/null || echo 0)

#TODO: Add BR: perl(Test::Pod::Spelling::CommonMistakes) when available
#TODO: Add BR: perl(DBD::AnyData) >= 0.110 when available
#TODO: Add BR: perl(DBD::DBM) >= 0.06 when available

Name:		perl-SQL-Statement
Version:	1.405
Release:	2.%{__distinit}%{__distvers}
Summary:	SQL parsing and processing engine
Group:		Development/Libraries
License:	GPL+ or Artistic
URL:		http://search.cpan.org/dist/SQL-Statement/
Source0:	http://search.cpan.org/CPAN/authors/id/R/RE/REHSACK/SQL-Statement-%{version}.tar.gz
Patch0:		SQL-Statement-1.402-old-Test::More.patch
Patch1:		SQL-Statement-1.402-older-Test::More.patch
Patch2:		SQL-Statement-1.401-trig.patch
Patch3:		SQL-Statement-1.401-hashref.patch
Patch4:		SQL-Statement-1.401-csch.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildArch:	noarch
BuildRequires:	perl(base)
BuildRequires:	perl(Carp)
BuildRequires:	perl(Clone) >= 0.30
BuildRequires:	perl(constant)
BuildRequires:	perl(Cwd)
BuildRequires:	perl(Data::Dumper)
# DBD::CSV buildrequires SQL::Statement
%if 0%{!?perl_bootstrap:1}
BuildRequires:	perl(DBD::CSV) >= 0.30
%endif
BuildRequires:	perl(DBD::File) >= 0.40
BuildRequires:	perl(DBD::SQLite)
BuildRequires:	perl(DBI::DBD::SqlEngine) >= 0.03
BuildRequires:	perl(Exporter)
BuildRequires:	perl(ExtUtils::MakeMaker)
BuildRequires:	perl(File::Path)
BuildRequires:	perl(File::Spec)
BuildRequires:	perl(lib)
BuildRequires:	perl(MLDBM)
BuildRequires:	perl(Params::Util) >= 1.00
BuildRequires:	perl(Scalar::Util) >= 1.0
BuildRequires:	perl(Test::More)
BuildRequires:	perl(Test::Pod) >= 1.00
BuildRequires:	perl(Test::Pod::Coverage) >= 1.00
BuildRequires:	perl(Test::Simple)
BuildRequires:	perl(Text::Soundex)
BuildRequires:	perl(Time::HiRes)
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Requires:	perl(Text::Soundex)

%description
The SQL::Statement module implements a pure Perl SQL parsing and execution
engine.	While it by no means implements full ANSI standard, it does support
many features including column and table aliases, built-in and user-defined
functions, implicit and explicit joins, complexly nested search conditions, and
other features.

%prep
%setup -q -n SQL-Statement-%{version}
chmod -c -x Changes README \
	lib/SQL/Eval.pm \
	lib/SQL/Statement.pm \
	lib/SQL/Dialects/ANSI.pm \
	lib/SQL/Dialects/AnyData.pm \
	lib/SQL/Dialects/CSV.pm \
	lib/SQL/Statement/GetInfo.pm \
	lib/SQL/Statement/RAM.pm \
	lib/SQL/Statement/Util.pm
perl -pi -e 's/\r\n/\n/' README

# Tests must be planned properly if we have Test::More < 0.88
%if %{old_test_more}
%patch0 -p1
%endif

# Can't use note() if we have Test::More < 0.82
%if %{older_test_more}
%patch1 -p1
%endif

# Some of the trig fails fail on old perls
%if %(perl -e 'print $] < 5.012000 ? 1 : 0;')
%patch2
%endif

# Get "Can't use string as a hashref" errors on older perls
%if %(perl -e 'print $] < 5.010000 ? 1 : 0;')
%patch3
%endif

# Avoid division by zero in csch and coth on older perls
%if %(perl -e 'print $] < 5.008008 ? 1 : 0;')
%patch4
%endif

%build
export SQL_STATEMENT_WARN_UPDATE=sure
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -exec rm -f {} ';'
%{_fixperms} %{buildroot}

%check
make test

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc Changes README README.md
%{perl_vendorlib}/SQL/
%{_mandir}/man3/SQL::Dialects::ANSI.3pm*
%{_mandir}/man3/SQL::Dialects::AnyData.3pm*
%{_mandir}/man3/SQL::Dialects::CSV.3pm*
%{_mandir}/man3/SQL::Dialects::Role.3pm*
%{_mandir}/man3/SQL::Eval.3pm*
%{_mandir}/man3/SQL::Parser.3pm*
%{_mandir}/man3/SQL::Statement.3pm*
%{_mandir}/man3/SQL::Statement::Embed.3pm*
%{_mandir}/man3/SQL::Statement::Function.3pm*
%{_mandir}/man3/SQL::Statement::Functions.3pm*
%{_mandir}/man3/SQL::Statement::GetInfo.3pm*
%{_mandir}/man3/SQL::Statement::Operation.3pm*
%{_mandir}/man3/SQL::Statement::Placeholder.3pm*
%{_mandir}/man3/SQL::Statement::RAM.3pm*
%{_mandir}/man3/SQL::Statement::Roadmap.3pm*
%{_mandir}/man3/SQL::Statement::Structure.3pm*
%{_mandir}/man3/SQL::Statement::Syntax.3pm*
%{_mandir}/man3/SQL::Statement::Term.3pm*
%{_mandir}/man3/SQL::Statement::TermFactory.3pm*
%{_mandir}/man3/SQL::Statement::Util.3pm*

%changelog
* Wed Jul 24 2013 Paul Howarth <paul@city-fan.org> - 1.405-2
- Perl 5.18 rebuild

* Mon Jun 17 2013 Paul Howarth <paul@city-fan.org> - 1.405-1
- Update to 1.405
  - INSERT now expands incomplete rows

* Thu May 23 2013 Paul Howarth <paul@city-fan.org> - 1.404-1
- Update to 1.404
  - Re-enable cleanup test_output* after test done
  - Recommend Text::Soundex and do soundex-test only when we have it, because
    it's going to be removed from core for Perl 5.19

* Thu May 23 2013 Paul Howarth <paul@city-fan.org> - 1.403-1
- Update to 1.403
  - Fix documentation (CPAN RT#84889, CPAN RT#85257)

* Wed Dec 19 2012 Paul Howarth <paul@city-fan.org> - 1.402-1
- Update to 1.402
  - Add Math::Complex 1.56 as recommendation (CPAN RT#81926)
  - Add Math::BigInt 1.88 as recommendation (CPAN RT#81927)
  - Clarify Test::Simple 0.90 is required for building (CPAN RT#81925)
  - Fix leaking reference to open tables outside SQL::Statement::execute
    (fixes CPAN RT#81523)
  - looks_like_number identifies 'nan' as number sometimes (add regex to
    t/06virtual.t)

* Mon Oct 29 2012 Paul Howarth <paul@city-fan.org> - 1.401-1
- Update to 1.401
  - Switch to 3-digited minor version
  - Undo literal replaces in subqueries before passing them to the child parser
  - Fix doc typos (CPAN RT#71914, CPAN RT#76764)
  - Fix DROP TABLE behaviour and error detection
  - Improve documentation/tests for multiple JOINs (CPAN RT#69573)
  - Filling in the SQL92 gaps for functions (CPAN RT#72638)
- BR: perl(Time::HiRes)
- Update patch for old Test::More versions
- Add patch to work around trig test issues on old perls
- Add patch to avoid "Can't use string as a hashref" errors in tests on older
  perls
- Add patch to avoid division by zero in csch and coth on older perls

* Mon Jul 16 2012 Paul Howarth <paul@city-fan.org> - 1.33-8
- Perl 5.16 post-bootstrap rebuild

* Sun Jul 15 2012 Paul Howarth <paul@city-fan.org> - 1.33-7
- BR:/R: perl(Text::Soundex)
- BR: perl(base), perl(constant), perl(Cwd), perl(Exporter), perl(File::Path),
  perl(File::Spec), perl(lib) and perl(Test::More)
- Don't need to remove empty directories from the buildroot
- Drop support for old distributions prior to FC-3:
  - Don't need to define %%{perl_vendorlib}
  - Use DESTDIR rather than PERL_INSTALL_ROOT

* Wed Jul  6 2011 Paul Howarth <paul@city-fan.org> - 1.33-2
- Rebuild for perl 5.14.1 in Rawhide
- Add support for perl_bootstrap macro
- Nobody else likes macros for commands
- Fix dist tag for CentOS 6 and Scientific Linux

* Sun Feb  6 2011 Paul Howarth <paul@city-fan.org> - 1.33-1
- Update to 1.33:
  - Move test dependencies to (unreleased) Bundle::Test::SQL::Statement to
    avoid circular dependencies

* Wed Jan 19 2011 Paul Howarth <paul@city-fan.org> - 1.32-1
- Update to 1.32:
  - Fix invalid check for escaped single quotes
  - Fix unpermitted modification of array source for table creation
    (CREATE TABLE AS IMPORT(?),[[..],[..]])
  - Fix alias used in ORDER BY (CPAN RT#61384)
  - Fix ORDER BY behaviour for multiple sort columns (slower, but guaranteed
    correct)
  - Rename fetch-method into fetch_row (keep fetch() as alias) and add a
    fetch_rows() to fetch all rows at once
  - Different accessors for direction of ORDER BY clause query part and its
    boolean equivalent "desc" (0 or 1, respectively)
  - Add a lot of Pure-Perl DBD's as build dependencies for testing
  - Bump requirement of DBI to 1.616
  - Switch for fully external DBD tests from DBD::XBase to DBD::SQLite
  - Document another limitation (lacking implicit creating temp table during
    processing a query using the same table with different aliases twice)
- Bump perl(DBD::CSV) version requirement to 0.30
- Bump perl(DBD::File) version requirement to 0.40
- Bump perl(DBI::DBD::SqlEngine) version requirement to 0.03
- BR: perl(DBD::SQLite) and perl(MLDBM)
- Update patch for old Test::More versions

* Mon Aug 16 2010 Paul Howarth <paul@city-fan.org> - 1.31-1
- Update to 1.31:
  - Fix misbehaviour of DELETE/UPDATE for some tables
  - Fix some column identifier splits to respect quoted tables
  - Optimized some core routines between 25% and 50%
- Add patch to fix test suite with Test::More < 0.88

* Tue Aug 10 2010 Paul Howarth <paul@city-fan.org> - 1.30-2
- Add buildreq perl(DBD::CSV) now that SQL::Statement is bootstrapped

* Tue Aug 10 2010 Paul Howarth <paul@city-fan.org> - 1.30-1
- Import from Fedora
- Update to 1.30:
  - SQL::Statement >= 1.28 is expected not to work properly in combination with
	DBI 1.611 and below
  - SQL::Statement::ColumnValue now expects every table to be derived from
	SQL::Eval::Table
  - Introduce new "capability" method for SQL::Statement and SQL::Eval::Table
  - Add capability for "insert_new_row" to allow DBD::DBM to fix PK constrain
	on INSERT statements
  - Performance of IMPORT feature improved (CPAN RT#57322)
  - Expect every table object being derived from SQL::Eval::Table
  - Rewrite DELETE and UPDATE command based on table capabilities
  - Add abstract methods for all methods derived classes must override
	(this means, open_table for SQL::Statement deriveds must be overridden
	and all data access methods of tables - see SQL::Eval::Table for details)
  - Tests are fixed to use TEMP TABLES explicitly when required
  - Check for invalid column names fixed
  - Don't let deprecated parser structures stay alive in SQL::Statement when
	reusing the Parser
  - Method documentation of SQL::Statement and SQL::Eval::Table are improved
  - Add a Roadmap describing future plans for SQL::Statement (in addition to
	DBD::File::Roadmap
  - POD spelling and grammar fixes
  - Add some getters as documented in SQL::Statement::Structure (CPAN RT#59834)
  - Add missing import of function croak to SQL::Statement::Term::ColumnValue
  - Fix assignment of parser result (doesn't run with perl 5.13.3)

* Tue Jun  8 2010 Petr Pisar <ppisar@redhat.com> - 1.27-1
- 1.27 bump (do not backport, 1.22 lower-cases unquoted identifiers)
- Make tests fatal again

* Thu May 06 2010 Marcela Maslanova <mmaslano@redhat.com> - 1.20-3
- Mass rebuild with perl-5.12.0

* Mon Dec  7 2009 Stepan Kasal <skasal@redhat.com> - 1.20-2
- Rebuild against perl 5.10.1

* Wed Sep 23 2009 Stepan Kasal <skasal@redhat.com> - 1.20-1
- New upstream version

* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.15-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.15-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Wed Feb 27 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 1.15-4
- Rebuild for perl 5.10 (again)

* Mon Jan 28 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 1.15-3
- Rebuild for new perl

* Tue Oct 16 2007 Tom "spot" Callaway <tcallawa@redhat.com> - 1.15-2.2
- Add BR: perl(Test::More)

* Tue Oct 16 2007 Tom "spot" Callaway <tcallawa@redhat.com> - 1.15-2.1
- Correct license tag
- Add BR: perl(ExtUtils::MakeMaker)

* Thu Sep  7 2006 Jose Pedro Oliveira <jpo at di.uminho.pt> - 1.15-2
- Rebuild for FC6

* Fri Feb 24 2006 Jose Pedro Oliveira <jpo at di.uminho.pt> - 1.15-1
- Update to 1.15

* Mon Feb 20 2006 Jose Pedro Oliveira <jpo at di.uminho.pt> - 1.14-2
- Rebuild for FC5 (perl 5.8.8)

* Sun Sep 11 2005 Jose Pedro Oliveira <jpo at di.uminho.pt> - 1.14-1
- First build
